/******************************************************************************************
 *
 * Class AudioProvider
 *
 ******************************************************************************************/
abstract class AudioProvider implements Runnable {
	protected byte buffer[];
	protected int lenght;
	protected boolean available;

	public AudioProvider(int len) {
		lenght = len;
		available = false;
	}

	abstract void putAudio();
	
	public synchronized void getBuffer(byte[] out) {
		int i;
		
		try {
			while(available == false) {
				wait();
			}
		} catch (InterruptedException e) {
		}
		
		for(i=0; i<lenght; i++) {
			out[i] = buffer[i];
		}

		available = false;
		notify();
	}
}
