import java.net.*;
import java.io.*;

/******************************************************************************************
 *
 * Class ADPCMfromURLprovider
 *
 ******************************************************************************************/
class ADPCMfromURLprovider extends AudioProvider {
	private String name;
	private URL location;
	private DataInputStream input;
	private ADPCMdecoder decoder;
	private byte[] ADPCMbuffer;
	
	public ADPCMfromURLprovider(String n, int len) {
		super(len);
		
		name = n;
		decoder = new ADPCMdecoder(len);
		ADPCMbuffer = new byte[lenght/2];

		try {
			location = new URL(name);
			input = new DataInputStream(location.openStream());
		} catch (MalformedURLException e) {
                     System.out.println("ADPCMfromURLprovider: " + e);
		} catch (IOException e) {
                     System.out.println("ADPCMfromURLprovider: " + e);
		}
	}
	
	public void run() {
		try {
			while(input.available() >= lenght/2) {
				putAudio();
			}
		} catch (IOException e) {
                     System.out.println("ADPCMfromURLprovider: " + e);
        }

		try {
			input.close();
		} catch (IOException e) {
                     System.out.println("ADPCMfromURLprovider: " + e);
        }
	}

	protected synchronized void putAudio() {
		try {
			while(available == true) {
				wait();
			}
		} catch (InterruptedException e) {
		}
		
		try {
			input.read(ADPCMbuffer, 0, lenght/2);
		} catch (IOException e) {
                     System.out.println("ADPCMfromURLprovider: " + e);
        }
		decoder.putADPCM(ADPCMbuffer);
		decoder.decode();
		buffer = decoder.getBuffer();
		available = true;
		notify();
	}

}
