//******************************************************************************
// AudioPlayer.java:	Applet
//
//******************************************************************************
import java.applet.*;
import java.awt.*;

//==============================================================================
// Main Class for applet AudioPlayer
//
//==============================================================================
public class AudioPlay extends Applet implements Runnable
{
	// THREAD SUPPORT:
	//		m_AudioPlayer	is the Thread object for the applet
	//--------------------------------------------------------------------------
	Thread	 m_AudioPlayer = null;

	// PARAMETER SUPPORT:
	//		Parameters allow an HTML author to pass information to the applet;
	// the HTML author specifies them using the <PARAM> tag within the <APPLET>
	// tag.  The following variables are used to store the values of the
	// parameters.
    //--------------------------------------------------------------------------

    // Members for applet parameters
    // <type>       <MemberVar>    = <Default Value>
    //--------------------------------------------------------------------------
	private String m_clip = "";

    // Parameter names.  To change a name of a parameter, you need only make
	// a single change.  Simply modify the value of the parameter string below.
    //--------------------------------------------------------------------------
	private final String PARAM_clip = "clip";


	Thread providerThread = null;
	ADPCMfromURLprovider provider;
	AudioPlayBuffer player;
	byte[] buffer;
	
	// AudioPlayer Class Constructor
	//--------------------------------------------------------------------------
	public AudioPlay()
	{
		// TODO: Add constructor code here
		buffer = new byte[800];
	}

	// APPLET INFO SUPPORT:
	//		The getAppletInfo() method returns a string describing the applet's
	// author, copyright date, or miscellaneous information.
    //--------------------------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: AudioPlayer\r\n" +
		       "Author: Tomasz Stachowiak\r\n" +
		       "Created with Microsoft Visual J++ Version 1.0";
	}

	// PARAMETER SUPPORT
	//		The getParameterInfo() method returns an array of strings describing
	// the parameters understood by this applet.
	//
    // AudioPlayer Parameter Information:
    //  { "Name", "Type", "Description" },
    //--------------------------------------------------------------------------
	public String[][] getParameterInfo()
	{
		String[][] info =
		{
			{ PARAM_clip, "String", "Compressed audio clip" },
		};
		return info;		
	}

	// The init() method is called by the AWT when an applet is first loaded or
	// reloaded.  Override this method to perform whatever initialization your
	// applet needs, such as initializing data structures, loading images or
	// fonts, creating frame windows, setting the layout manager, or adding UI
	// components.
    //--------------------------------------------------------------------------
	public void init()
	{
		// PARAMETER SUPPORT
		//		The following code retrieves the value of each parameter
		// specified with the <PARAM> tag and stores it in a member
		// variable.
		//----------------------------------------------------------------------
		String param;

		// clip: Compressed audio clip
		//----------------------------------------------------------------------
		param = getParameter(PARAM_clip);
		if (param != null)
			m_clip = param;

        // If you use a ResourceWizard-generated "control creator" class to
        // arrange controls in your applet, you may want to call its
        // CreateControls() method from within this method. Remove the following
        // call to resize() before adding the call to CreateControls();
        // CreateControls() does its own resizing.
        //----------------------------------------------------------------------
		resize(320, 240);

		// TODO: Place additional initialization code here
	}

	// Place additional applet clean up code here.  destroy() is called when
	// when you applet is terminating and being unloaded.
	//-------------------------------------------------------------------------
	public void destroy()
	{
		// TODO: Place applet cleanup code here
	}

	// AudioPlayer Paint Handler
	//--------------------------------------------------------------------------
	public void paint(Graphics g)
	{
		// TODO: Place applet paint code here
		g.drawString("Running: " + Math.random(), 10, 20);
	}

	//		The start() method is called when the page containing the applet
	// first appears on the screen. The AppletWizard's initial implementation
	// of this method starts execution of the applet's thread.
	//--------------------------------------------------------------------------
	public void start()
	{
		player = new AudioPlayBuffer();
		provider = new ADPCMfromURLprovider(m_clip, 800);

		if (m_AudioPlayer == null)
		{
			m_AudioPlayer = new Thread(this);
			m_AudioPlayer.start();
		}

		// TODO: Place additional applet start code here
		if(providerThread == null) {
			providerThread = new Thread(provider);
			providerThread.start();
		}
	}
	
	//		The stop() method is called when the page containing the applet is
	// no longer on the screen. The AppletWizard's initial implementation of
	// this method stops execution of the applet's thread.
	//--------------------------------------------------------------------------
	public void stop()
	{
		if (m_AudioPlayer != null)
		{
			m_AudioPlayer.stop();
			m_AudioPlayer = null;
		}

		// TODO: Place additional applet stop code here
		if(providerThread != null) {
			providerThread.stop();
			providerThread = null;
		}
	}

	// THREAD SUPPORT
	//		The run() method is called when the applet's thread is started. If
	// your applet performs any ongoing activities without waiting for user
	// input, the code for implementing that behavior typically goes here. For
	// example, for an applet that performs animation, the run() method controls
	// the display of images.
	//--------------------------------------------------------------------------
	public void run()
	{
		while (true)
		{
			try
			{
				repaint();
				// TODO:  Add additional thread-specific code here
				provider.getBuffer(buffer);
				player.play(buffer);
				
				Thread.sleep(100);
			}
			catch (InterruptedException e)
			{
				// TODO: Place exception-handling code here in case an
				//       InterruptedException is thrown by Thread.sleep(),
				//		 meaning that another thread has interrupted this one
				System.out.println("AudioPlay: " + e);
				stop();
			}
		}
	}



	// TODO: Place additional applet code here

}
