/*********************************************************************
 *
 * File:         daemon.h
 *
 * Description:  Header of conference engine daemon
 *
 * Author:       Tomasz Stachowiak, NPAC
 *
 * Date:         10-14-96
 *
 *********************************************************************/

#ifndef _DAEMON_H
#define _DAEMON_H

/* Daemon data */
typedef struct _daemon_data
{
  SOCKET socket;
  SOCKADDR_IN addr;
} DaemonData;

/* Raw message structure, used to determine the message is local */ 
typedef struct _raw_msg
{
  char local;
  char data[1];
} RawMessage;


int sendControlPacket(SOCKADDR_IN *addr, char *msg, int len);
void messageHandle(char *msg, int len, SOCKADDR_IN *addr);
void handleLocalMessage(char *msg, int len);
void handleRemoteMessage(char *msg, int len);

void initDaemon();
void runDaemon();

#endif