///////////////////////////////////////////////////////////////////////////
// 
// File						: VideoProtocol.h
//
// Description				: Video application protocol
//
// Author					: Tomasz Stachowiak
//
// Date						: 11-21-96
//
////////////////////////////////////////////////////////////////////////////
#define VIDEO_PLUGIN_PORT   34999   /* plugin-to-plugin communication */

#define MAX_FRAME_SIZE	    20000

//////////////////
// app state
#define STOP	0
#define	PLAY	1
#define PANEL   2


//////////////////
// source types
#define SGI 1
#define PC 2

/////////////////////////////
// Application messages tags
typedef enum {
   H263 = 0,
   H261,   
  videoTagInvalid,     /* Never used */
  videoTagPlay,    
  videoTagConfirm,    
  videoTagStop,
  videoTagExit,
  videoTagData,
  videoTagFrameDecoded,
  videoTagNewMember
} VideoTag;

typedef struct _videoPluginFrame
{
  struct timeval time;
  char data[1];
} VideoPluginFrame;
    

typedef struct videoPluginArg {
	unsigned char sourceType;		// type of data source (SGI or PC)
	int frate;						/* suggested frame rate */
	int format;						/* required picture format */
} VideoPluginArg;















