/*********************************************************************
 *
 * File:         common.cpp
 *
 * Description:  NPAC Conferencing System API functions for session 
 *               management 
 *
 * Author:       Tomasz Stachowiak, NPAC
 *
 * Date:         10-14-96
 *
 *********************************************************************/
#include <stdio.h>

#include "common.h"

extern ManagerData managerData;

void nic()
{
}


/* The lowest level control packages sending procedure */
int sendControlPacket(struct sockaddr_in *addr, char *msg, int len)
{
  if(sendto(managerData.socket, msg, len, 
	 0, (SOCKADDR *)addr, sizeof(struct sockaddr_in)) < 0)
    return 0;  

  return 1;
}

int getHostFullName(char *name, int len)
{
	char tmp[100];
	struct hostent *hostinfo;

	gethostname(tmp, 100);
  
	hostinfo = gethostbyname(tmp);
	if(hostinfo == NULL)
    {
		return 0;
    }
	
	strcpy(name, hostinfo->h_name);
	
	return 1;
}

int ncsEngineRequest(short tag, char *data, int len)
{
  Message *msg;
  int size;
  DWORD user_len=20;

  size = sizeof(Message) + len - 1;
  msg = (Message *)malloc(size);
  if(msg == NULL)
    fprintf(stderr, "Manager: control message allocation error\n");
  msg->local = 1;
  msg->tag = tag;
  memcpy(msg->data, data, len);
  GetUserName(msg->sender.user, &user_len);
  getHostFullName(msg->sender.host, 50);

  if(sendControlPacket(&managerData.daemon_addr, (char *)msg, size) < 0)
    return 0; 

  return 1;
}

/* The lowest level data packages sending procedure */
int sendPacket(int socket, struct sockaddr_in *addr, char *msg, int len)
{
  if(sendto(socket, msg, len, 
	 0, (SOCKADDR *)addr, sizeof(struct sockaddr_in)) < 0)
    return 0;  

  return 1;
}












