///////////////////////////////////////////////////////////////////////////
// 
// File						: Conference.h
//
// Description				: Conference functions declarations
//
// Author					: Tomasz Stachowiak
//
// Date						: 11-15-96
//
////////////////////////////////////////////////////////////////////////////
#ifndef _CONFERENCE_H
#define _CONFERENCE_H

#include "ncs.h"
#include "adpcm.h"
#include "gsm.h"
#include "TSaudio.h"
#include "TSaudioDlg.h"

#define		AUDIO_PLUGIN_PORT      12567
#define         VERSION      		1

#define MAX_USERS 100

#define ADPCM 13
#define GSM 14

#define DUPLEX 20
#define HALF_DUPLEX 21

#define TRESHOLD 2000

typedef struct _audioMessage
{
  char buf[400];
}  audioPluginMessageStructure;



typedef enum _states
{
	stateStart,
	stateStop
} States;

class Conference
{
private:
	void checkTimer();
	void HandleDuplexAudio(char *buffer, short level, DWORD handle);
	void HandleHalfDuplexAudio(char *buffer, short level, DWORD handle);
	ncsApplication *ncsApp;
	States state;
	int code_type;
	HANDLE hThread;
	DWORD dwThreadId;
	struct adpcm_state adpcmstates[MAX_USERS];
	struct adpcm_state adpcmsendstate;
	int mode;
	int first[MAX_USERS];
	CTSaudioDlg *main_dlg;
	int silence_no;
	gsm gsmHandle;
	int current_sender;
	int treshold;


	void HandleData(DWORD tag, void *data, int len, DWORD handle);

public:
	UINT timer;
	void setTalk(int check);
	void setAuto(int check);
	Conference(CTSaudioDlg *dlg);
	int hardwareInit();
	static DWORD ReadThread(LPDWORD lpdwParam);
	void SendData(char *data);
	void StartSending(void);
	void StopSending(void);
	void codeADPCM(void);
	void codeGSM(void);
	void setTreshold(UINT level);
	~Conference(void);
	VOID static CALLBACK TimerCallback(
		HWND hwnd,	// handle of window for timer messages 
		UINT uMsg,	// WM_TIMER message
		UINT idEvent,	// timer identifier
		DWORD dwTime 	// current system time
	);
	
protected:
	int automatic;
	int talk;
};

#endif
