/*********************************************************************
 *
 * File:         daemon.h
 *
 * Description:  Header of conference engine daemon
 *
 * Author:       Tomasz Stachowiak, NPAC
 *
 * Date:         10-14-96
 *
 *********************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>

#include <netdb.h>
#include <unistd.h>

/* Daemon data */
typedef struct _daemon_data
{
  int socket;
  struct sockaddr_in addr;
} DaemonData;

/* Raw message structure, used to determine the message is local */ 
typedef struct _raw_msg
{
  char local;
  char data[1];
} RawMessage;


void readMemberMessage(int no);
void readAppMessage(int no);
void readLocalMessage();
void readNewMessage();
void readInviteMessage();

void handleLocalMessage(MsgHeader *header, char *msg, int len);
void handleAppMessage(int no, MsgHeader *header, char *msg, int len);
void handleNewMessage(struct sockaddr_in *addr, MsgHeader *header, char *msg, int len);
void handleMemberMessage(int no, MsgHeader *header, char *msg, int len);

void initDaemon();
void quitDaemon();
void runDaemon();
